/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.jca;

import org.codehaus.activemq.bean.Requestor;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueSession;
import javax.jms.TextMessage;
import java.util.Date;

/**
 * @version $Revision: 1.2 $
 */
public class JCAContainerRequestReplyTest extends JCAContainerTestSupport {

    public void testRequestReply() throws Exception {
        Queue queue = session.createQueue(getClass().getName());
        Requestor requestor = new Requestor((QueueSession) session, queue);

        TextMessage message = session.createTextMessage("Hello! " + new Date());

        System.out.println("About to send: " + message);


        Message answer = requestor.request(message);

        assertTrue("Should have received an answer", answer != null);

        System.out.println("Received: " + answer);
    }


    protected XmlBeanFactory createBeanFactory() {
        return new XmlBeanFactory(new ClassPathResource("spring-request-reply.xml", getClass()));
    }
}
